/// <reference types="node" />
export declare const isWindows: boolean;
import { ExecOptions } from "child_process";
import * as filesystem from 'fs';
export declare function readdir(path: any): Promise<Array<string>>;
export declare function stat(path: any): Promise<filesystem.Stats>;
export declare function lstat(path: any): Promise<filesystem.Stats>;
export declare function open(path: filesystem.PathLike, flags: string | number, mode?: string | number | undefined | null): Promise<number>;
export declare function close(fd: number): Promise<void>;
export declare function write(fd: number, buffer: Buffer, offset?: number, length?: number, position?: number): Promise<number>;
export declare function read(fd: number, buffer: Buffer, offset: number, length: number, position?: number): Promise<number>;
export declare function readFile(path: filesystem.PathLike, options?: {
    encoding?: string | null;
    flag?: string;
}): Promise<string | Buffer>;
export declare function execute(command: string, options: ExecOptions): Promise<{
    stdout: string;
    stderr: string;
    error: Error | null;
    code: number;
}>;
export declare function rename(oldPath: string, newPath: string): Promise<void>;
export declare function writeFile(filename: string, content: string): Promise<void>;
export declare function copyFile(source: string, target: string): Promise<void>;
export declare const exists: (path: string | Buffer) => Promise<boolean>;
export declare function isDirectory(dirPath: string): Promise<boolean>;
export declare function isFile(filePath: string): Promise<boolean>;
export declare function rmdir(dirPath: string): Promise<void>;
export declare function rmFile(filePath: string): Promise<void>;
export declare function mkdir(dirPath: string): Promise<void>;
export declare const INTSIZE = 6;
/** Strips down a path into an absolute-style unix path (WIN32 only) */
export declare const unixifyPath: (p: any) => any;
export declare const isWindowsPath: (p: any) => any;
export declare function calculateHash(content: any): string;
export declare function select<T, V>(array: Array<V>, callbackfn: (accumulator: Array<T>, current: V, index: number, array: V[]) => T): Array<T>;
export declare function selectMany<T, V>(array: Array<V>, callbackfn: (accumulator: Array<T>, current: V, index: number, array: V[]) => Array<T>): Array<T>;
export declare function first<T, V>(array: Array<V>, selector: (current: V) => T | undefined, onError?: () => undefined): T | undefined;
export declare function backup(filename: string): Promise<() => void>;
